/* MagnetiCE header file */
/* (C) 2004 N Lines (nick@chiark.com) */

#define dim(x) (sizeof(x) / sizeof(x[0]))


//User interface defines for our resource file
#define IDC_CMDBAR 1

struct decodeUINT {						//With credit to D Boling for the structure idea
	UINT code;							//Associate a message with a function
	LRESULT (*fxn)(HWND,UINT,WPARAM,LPARAM);
};

struct decodeCMD {
	UINT code;
	LRESULT (*fxn)(HWND,WORD,HWND,WORD);
};


//Function prototypes

int initApp(HINSTANCE);
HWND initInstance(HINSTANCE,LPWSTR, int);
int terminateInstance(HINSTANCE,int);
int initiateBuffers(int);
void getFontAndScreenMetrics(HWND hWnd);  
void renderPicture(void);

void getSettingsFromRegistry(void);
void writeSettingsToRegistry(void);


LRESULT CALLBACK mainWndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK gfxWndProc(HWND hWnd,UINT wMsg,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK aboutDialogProc(HWND hWnd,UINT wMsg,WPARAM wParam,LPARAM lParam);

LRESULT doCreateMain(HWND hWnd,UINT wMsg, WPARAM wParam, LPARAM lParam);
LRESULT doPaintMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doKeysMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doDestroyMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doInitMenuPopMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doSizeMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doCommandMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doSetFocusMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doKillFocusMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doHelpMain(HWND,UINT,WPARAM,LPARAM);
LRESULT doShowGfx(HWND,UINT,WPARAM,LPARAM);


LPARAM doMainCommandOpen(HWND,WORD,HWND,WORD);
LPARAM doMainCommandLoad(HWND,WORD,HWND,WORD);
LPARAM doMainCommandSave(HWND,WORD,HWND,WORD);
LPARAM doMainCommandExit(HWND,WORD,HWND,WORD);
LPARAM doMainCommandUndo(HWND,WORD,HWND,WORD);
LPARAM doMainCommandFont(HWND,WORD,HWND,WORD);
LPARAM doMainCommandAbout(HWND,WORD,HWND,WORD);


//Thread stuff
DWORD WINAPI gameThread(LPVOID lpArg);